<template>
  <div style="text-align: center;">
    <div
      class="col-sm-8"
      style="text-align: left"
    >
      <p>Transmettez ci-dessous une image afin de changer l'apparence de vos interfaces et de celles de vos utilisateurs.</p>
      <p><u>Éléments graphiques impactés :</u></p>
      <ul>
        <li>Bandeau "header" site</li>
        <li>Image de mailing</li>
        <li>Image de rapport PDF</li>
      </ul>
    </div>
    <div class="col-sm-2">
      <click-button
        v-if="logoNotExist === false"
        @click="performRemoveLogo()"
      >
        <template #content>
          Supprimer votre logo personnalisé
        </template>
      </click-button>
    </div>
    <div class="col-sm-6">
      <logo-upload-form
        :reset="resetForm"
        @logoUploaded="displayImageToCrop"
        @formReseted="formHasReset"
      />
    </div>
    <div class="col-sm-6">
      <crop-image
        :image-url="imageUrl"
        :file="file"
        @logoUpdated="reset"
      />
    </div>
  </div>
</template>

<script>
import LogoUploadForm from "./../../../../components/Form/Upload/LogoUploadForm";
import CropImage from "./../../../../components/Image/CropImage";
import {mapActions, mapGetters} from "vuex";
import VanillaToasts from "vanillatoasts";
import ClickButton from "../../../../components/Button/ClickButton";
export default {
  name: "Customization",
  components: {ClickButton, CropImage, LogoUploadForm},
  data() {
    return {
      imageUrl: '',
      file: null,
      resetForm: 0
    }
  },
  computed: {
    ...mapGetters([
      'logo'
    ]),
    logoNotExist() {
      return this.logo == null
    },
  },
  methods: {
    ...mapActions([
      'loadingStarts',
      'loadingEnds',
      'removeLogo'
    ]),
    displayImageToCrop(urlAndFileUploaded) {
      this.imageUrl = urlAndFileUploaded.url
      this.file = urlAndFileUploaded.file
    },
    performRemoveLogo() {
      this.loadingStarts()
      this.removeLogo()
        .then(()=>{
          VanillaToasts.create({
            title: 'Suppression de logo',
            text: 'Opération effectuée avec succès',
            type: 'success',
            timeout: 10000,
          });
          this.loadingEnds()
        })
        .catch(()=>{
          this.loadingEnds()
        })
    },
    reset() {
      this.imageUrl = ''
      this.resetForm = 1
    },
    formHasReset() {
      this.resetForm = 0
    }
  }
}
</script>

<style scoped>

</style>